/*
Anmerkung von pps: 	Ich habe einfach mal einiges in .proc und .endp geschachtelt und auch zum start noch
			etwas ausgelagert. Da kann man natrlich noch viel mehr machen. Resultat: Man kann die
			.proc einfach auch mal ausblenden indem man links auf das Minus klickt und der Quellcode
			wird durch mehrere Dateien deutlich kleiner. Ich packe diese meist noch in verschiedene
			Verzeichnisse - sowas, wie Grafik, Sound, Interrupts etc. So bleibt auch das DIR bersichtlich.
*/


			org $2000

			icl '../hardware.txt'
			icl '../header.txt'
			icl 'character.asm'
			icl 'lands.asm'	
        
	.proc dlist
		   	.byte 112,112,112,100
			.byte 30,75
			.byte 36,36,36,36,36,36,36,36,36,36,36,36
			.byte 36,36,36,36,36,36,36,36,36,4,4,4,4,4
			.byte 65,32,156
	.endp
/*
oder DL komplett ndern:
	.proc dlist
		   	.by 112,112,112,100
			.by 30,75
			.by 36,36,36,36,36,36,36,36,36,36,36,36
			.by 36,36,36,36,36,36,36,36,36,4,4,4,4,4
			.by 65
			.wo dlist
	.endp
dann einfach mit mwa #DLI 560 direkt anschalten statt jsr displaylist - das ganze .proc displaylist kann dan weg
ich persnlich schreibe DL auch immer in hex, da ist es einfacher fr mich die ganzen Modi und Zeilen zu erkennen.
Bsp.:
	.he 70 70 70 64		;3x8 Leerzeilen, dann LMS + mode 4
	.wo $4b1e		;screenadresse	(btw Wo kommt der krumme Wert her?)
:21	.he 24			;mode 4 + vscrol
:5	.he 04			;mode 4
	.he 41
	.wo dlist
*/

			icl 'pmg_vars.asm'
			
			.proc main
			
main1			jsr displaylist ;Subroutine Displaylist-Aufbau
			mva #30 yposp1
			mva #120 xposp1
			mva #42 yposm1
			mva #0 xposm1
			mva #94 yposm2
			mva #100 xposm2
			mva #0 tank1x
			mva #0 tank1y
			mva #151 fuelzaehleritem
			mva #0 fuelzaehler
			jsr text
						
Start1			mva #>chr chbas ;HighByte Character Pointer auf $2000 setzen
			mva #192 gprior	;GTIA Modus 3 
			mva #15 color3	;Schriftfarbe	
			mva #218 color1	;Gelb
			mva #154 color0	;Blau
			mva #52 color2	;Rot
			mva #180 color2	; Grün
			mva #0 color4 ;Hintergrundfarbe
			lda #0 \ tax \ sta var3 \ sta var4 \ sta var6 \ sta var7 \ sta var6+1
						
			; Player vorbereiten und initialisieren
			lda ramtop
			sec
			sbc #16
			sta pmbase
			clc
			adc #3
			sta miss1+1
			adc #1
			sta play1+1
			adc #3
			sta play4+1
			lda #9
			sta play4
			mva #62 sdmctl
			mva #56 pcolr0
			mva #56 pcolr1
			mva #142 pcolr2
			mva #142 pcolr3
			mva #1 gprior
			mva #3 gractl
			mva #1 sizep0
			mva #1 sizep1
			mva #0 sizem
			mva #0 rechts
			mva #2 hitclr
			mva #48 blink

main2			mva <lands var6
			mva >lands var6+1
			mva #0 kollp0
			ldy #255				;Speicher Player 1 leeren
			lda #0
			sta play1
@			sta (play1),y
			sta (play4),y
			dey
			bpl @-
			clc
			ldy yposp1					;verticale Startpos. Player 1 + füllen
			ldx #0
@			lda pm1,x
			sta (play1),y
			;lda pm41,x
			;sta (play4),y
			iny
			inx
			cpx #14
			bne @-
			clc
			ldy #0
			ldx #0
@			lda mi1,x
			sta (miss1),y
			iny
			inx
			cpx #2
			bne @-
			lda xposm1
			sta p0pf
			lda xposm2
			sta p1pf
			ldx #>vbinter			;VB-Interrupt VektorHi
			ldy #<vbinter			;VB-Interrupt VektorLo
			lda #7					;Deferred Mode mit lda #7 festlegen
			jsr setvbv				;Vektor für die eigene Routine über setvbv eintragen
									
hauptprogramm
			
			clc
			lda kollp0
			cmp #1
			bcc @+
			jsr kollision
			mva #0 kollp0
@			jsr letztereihe 		;letzte Reihe (lands) Bildschirm1 printen (sichtbar)	
			jsr feinscroll 			;Feinscroll Bildschirm1 ausführen (sichtbar)		
			mva #$30 var1			;var1 auf 30000 ($7530) setzen
			mva #$75 var1+1
			mva #$E4 var2			;var2 auf 31460 ($7AE4) setzen
			mva #$7A var2+1
			jsr grobscroll			;Bildschirm1 kopieren + grobscroll
			mva #$0C var1			;var1 + var2 auf 31500 ($7B0C) setzen
			mva #$0C var2
			mva #$7B var1+1
			mva #$7B var2+1	
			jsr umschalten
			inc fuelzaehleritem
			lda fuelzaehler
			tax
			lda fuelzaehleritem
			sta 31043,x
			sta 32543,x
			#if .byte fuelzaehleritem=#155
			mva #151 fuelzaehleritem
			inc fuelzaehler
			#end
			#if .byte fuelzaehler>#200
			mva #0 fuelzaehler
			#end
			#if .byte fuelzaehler=#20
			mva #52 color3
			#end
			#if .byte fuelzaehler>#34 .and .byte fuelzaehler<#200
			jmp main1				;Fuel zuende Neustart
			#end
			mva #0 kollm1
			mva #0 kollm2			;umschalten auf Bildschirm2 - Bildschirm2 wird sichtbar	
			jsr letztereihe
			jsr feinscroll			;Feinscroll Bildschirm2 ausführen (sichtbar)						
			mva #$08 var2			;var1 auf 29960 ($7508) setzen
			mva #$75 var2+1
			mva #$0C var1			;var2 auf 31500 ($7B0C) setzen
			mva #$7B var1+1
			#if .byte kollges=#4
			mva #15 color3
			sec
			lda fuelzaehler
			sbc #10
			sta fuelzaehler	
			tax
			mva #151 fuelzaehleritem
			clc
			lda fuelzaehleritem
@			sta 31043,x
			sta 32543,x
			inx
			cpx #36
			bne @-
			jsr kollitem
			mva #0 kollges
			#end
			mva #$08 var2			;var1 auf 29960 ($7508) setzen
			mva #$75 var2+1
			mva #$0C var1			;var2 auf 31500 ($7B0C) setzen
			mva #$7B var1+1
			jsr grobscroll			;;Bildschirm2 kopieren + grobscroll
			mva #$30 var1			;var1 + var2 auf 30000 ($7530) setzen
			mva #$30 var2
			mva #$75 var1+1
			mva #$75 var2+1
			;mva #1 delay
 			jsr umschalten			;umschalten auf Bildschirm1 - Bildschirm1 wird sichtbar
			inc fuelzaehleritem
			lda fuelzaehler
			tax
			lda fuelzaehleritem
			sta 31043,x
			sta 32543,x
			#if .byte fuelzaehleritem=#155
			mva #151 fuelzaehleritem
			inc fuelzaehler
			#end
			
			;Ende der Bildschirmausführung / Kontrolle Durchläufe
			sec
			lda #40	; - 36 = Anzahl der Durchläufe - auf 4 beschränkt, da die Landschaft noch rudimentär ist und sich dann wiederholen soll
			sbc var6+1
			bpl @+
			jmp start1			;Stop hier
@	 	
			jmp hauptprogramm	 			;weiter
			
			.endp
			
			; _____________________________________________________________________________________
			;
			; ---------------------------- S U B R O U T I N E N ----------------------------------
			; _____________________________________________________________________________________

								
			icl 'VBI.asm'
			; -------------------------------------------------------------------------------------

	.proc kollision
			ldx #0
			clc
@			inx
			cpx #255
			bcc @-
			rts
	.endp
			; -------------------------------------------------------------------------------------

	.proc umschalten
			ldy #4 				;Bildschirme umschalten von unsichtbar auf sichtbar	
			mva sdlstl var5
			mva sdlstl+1 var5+1
			lda var1
			sta (var5),y
			iny
			lda var1+1
			sta (var5),y
			rts
	.endp
			; -------------------------------------------------------------------------------------

	.proc wartes
			clc
 		   	ldx delay ; Warteschleife
st  			lda RTCLOK+2    
wa   			cmp RTCLOK+2    
        		beq wa    
        		dex            
        		bpl st 
        		rts
        .endp
        	; -------------------------------------------------------------------------------------
        	
	.proc feinscroll
			ldy #1
			mva #0 delay
@			jsr wartes
			sty vscrol
			iny
			cpy #8
			bne @-			
			rts
        .endp	
        	; --------------------------------------------------------------------------------------
        	
	.proc grobscroll	
			;Den Bildschirm um eins hoch / Grobscrolling um eine Zeile

			ldx #22
@			ldy #$28
			clc
@			lda (var1),y 
			sta itemex
			#if .byte itemex=#68
			jsr fuel
			#end
			sta (var2),y
			dey
			bpl @-
			clc
			lda var1
			adc #$28
			sta var1
			bcc @+
			inc var1+1
@			clc
			lda var2
			adc #$28
			sta var2
			bcc @+
			inc var2+1			
@			clc
			dex
			bpl @-3
			rts
	.endp		
			; -------------------------------------------------------------------------------
			
	.proc displaylist
			; initialisiere die Displaylist
			mva sdlstl var5
			mva sdlstl+1 var5+1
;es geht auch:		mwa sdlstl var5
			ldy #0
			clc
@			lda dlist,y
			sta (var5),y
			iny
			cpy #34
			bne @-
			rts
;oder einfach direkt die neue DL nutzen ohne das genze gepoke
;			mwa #dlist 560
;dazu oben aber dlist anpassen, wie oben schon auskommentiert

	.endp		
			; ---------------------------------------------------------------------------------------
			
	.proc letztereihe
			;Die letzte Reihe printen 
			;Start der letzten Reihe bei var1 - Line 22
			;in Var6 (+1) wird die Position von lands gespeichert
			;in Var5 gehen Infos der Boarderanzahl rein
			;in y ist der Zähler für letzte Reihe
			;x wird als Zähler fürs printen benutzt
			
			lda var1+1
			;sta var8+1
			;sta var7+1
			lda var1
			;sta var8
			;sta var7
			adc #112
			sta var1
			inc var1+1
			inc var1+1
			inc var1+1
			ldy #0
			clc
			lda (var6),y 	;Boarderanzahl 1 holen
			sta var5 		;Boarderanzahl 1 in var5 speichern
			jsr var6up
			lda (var6),y	;Boarderart 1 holen
			ldy var5		;Zeilenzählen in y übertragen
@			sta (var1),y 	;Boarder1 printen
			dey
			bpl @-			
			jsr var6up
			adc #0
			sta var6+1
			lda (var6),y	;Boarderanzahl 2 holen
			tax
			jsr var6up
			lda (var6),y	;Boarderart 2 holen
			ldy var5
@			iny			 
			sta (var1),y 	;leer printen
			dex
			bpl @-
			sty var5		;Zeilenzähler sichern
			jsr var6up
			lda (var6),y 	;Rand Boarder2 holen
			inc var5		;Zeilenzähler eins weiter
			ldy var5	
			sta (var1),y 	;Rand Boarder1 printen
			jsr var6up
			inc var5
			lda(var6),y 	;leer holen
			tax
			lda #0
			ldy var5			
@			iny			 
			sta (var1),y 	;leer printen
			dex
			bpl @-
			sty var5 		;Zeilenzähler sichern
			jsr var6up
			lda(var6),y 	;Rand Boarder3 holen
			ldy var5
			iny
			sty var5
			sta (var1),y 	;Rand Boarder3 printen
			jsr var6up
			lda(var6),y 	;Boarder4 holen
			tax 			;Boarderanzahl in x speichern
			jsr var6up
			lda (var6),y
			ldy var5
@			iny
			sta (var1),y	;Boarder4 printen
			dex
			bpl @-
			sty var5 		;Zeilenzähler sichern
			jsr var6up
			lda(var6),y 	;Boarder5 holen
			tax 			;Boarderanzahl in x speichern
			jsr var6up
			lda (var6),y
			ldy var5
@			iny
			sta (var1),y	;Boarder5 printen
			dex
			bpl @-
			jsr var6up
			lda (var6),y	;Sonderitem holen
			sta var5		;Item in Var5 speichern
			jsr var6up
			#if .byte var5=#56	;Öltank printen
			#if .byte tank1x=#0
			mva var1 tank1y
			mva var1+1 tank1y+1
			sec
			lda tank1y
			sbc #120
			sta tank1y
			lda tank1y+1
			sbc #0
			sta tank1y+1
			#end
			lda (var6),y		;Startposition des Items in y speichern
			sta tank1x
			tay
			jsr fuel			;Fueltank printen
			#end
			jsr var6up
			mva #0 vscrol
			sec
			lda tank1y
			sbc #40
			sta tank1y
			lda tank1y+1
			sbc #0
			sta tank1y+1
			lda tank1x
			tay
			mva #0 var5
			rts
						
var6up			clc
			lda var6
			adc #1
			sta var6
			ldy #0
			lda var6+1
			adc #0
			sta var6+1
			rts
	.endp
			; --------------------------------------------------------------------------------------
			
	.proc fuel
			sec				;Routine um den Öltank zu printen - es werden 12 Character meanderförmig geprinten 3x4 Matrix
			lda var1
			sbc #160
			sta var2
			lda var1+1
			sbc #0
			sta var2+1
fuelex			lda var5
			sta (var2),y	;1
			inc var5
			lda var5
			iny
			sta (var2),y	;2
			inc var5
			lda var5
			iny
			sta (var2),y	;3
			clc
			lda var2
			adc #41
			sta var2
			lda var2+1
			adc #0
			sta var2+1
			dey
			inc var5
			lda var5
			sta (var2),y	;4
			dey
			inc var5
			lda var5
			sta (var2),y	;5
			dey
			inc var5
			lda var5
			sta (var2),y	;6
			clc
			lda var2
			adc #40
			sta var2
			lda var2+1
			adc #0
			sta var2+1
			inc var5
			lda var5
			sta (var2),y	;7
			inc var5
			lda var5
			iny
			sta (var2),y	;8
			inc var5
			lda var5
			iny
			sta (var2),y	;9 
			clc
			lda var2
			adc #40
			sta var2
			lda var2+1
			adc #0
			sta var2+1
			inc var5
			lda var5
			sta (var2),y	;10
			dey
			inc var5
			lda var5
			sta (var2),y	;11
			dey
			inc var5
			lda var5
			sta (var2),y	;12
			tya
			rts
	.endp
			; ------------------------------------------------------------------------------


	.proc kollitem					;Kollisionsroutine
							;var8 unveränderter Bildschirmanfang 			
			lda yschuss1	;in Gr.0 -32 (sichtbarer Bereich ab 32 und /8
			sec
			sbc #32
			clc
			ror
			clc
			ror
			clc
			ror
			sta yschuss1	;y-Position in das x-Register schreiben
			tax	
			dex				; und einen abziehen
			lda xschuss1	;x-Position -48 (sichtbarer Bereich)und /4
			sec
			sbc #48
			clc
			ror
			clc
			ror
			tay				;in y geht die x-Position
			sec
			mva var1 var2		;holen der Bildschirmadresse -> var2
			mva var1+1 var2+1
			clc
@			lda var2		;jetzt die y-Position auf die richtige Höhe stellen
			adc #40
			sta var2
			lda var2+1
			adc #0
			sta var2+1
			dex
			bpl @-			;die y-Position steht in x - Addition von x Zeilen
@			dey				;die korrekte x-Position einstellen
			lda (var2),y	;linken Rand checken
			sta var8		
			iny
			iny
			lda (var2),y	;rechten Rand checken
			sta var9
			dey
			dey
			#if .byte var8=#0 .and .byte var9>#0	;Position nach rechts anpassen 
			iny
			#end
			#if .byte var8>#0 .and .byte var9=#0	;Position nach links anpassen
			dey
			#end
			lda (var2),y		;2. Durchgang der Anpassung um letzte 
			sta var8			;Fehler zu beseitigen
			iny
			iny
			lda (var2),y
			sta var9
			dey
			dey
			#if .byte var8=#0 .and .byte var9>#0
			iny
			#end
			#if .byte var8>#0 .and .byte var9=#0
			dey
			#end
			lda (var2),y		;Korrektur der y-Position
			sta var8			;in var8 aktuelle BS-Position
			sec
			lda var2			;eins drüber - bleibt wenn var2 zu tief
			sbc #40
			sta var2
			lda var2+1
			sbc #0
			sta var2+1
			lda (var2),y		;lade Bildschirminhalt eins drüber
			sta var9			;das geht in var9 rein
			#if .byte var8>#0 .and .byte var9=#0	;alte Position var2 
			clc										;wiederherstellen
			lda var2
			adc #40
			sta var2
			lda var2+1
			adc #0
			sta var2+1
			#end
			#if .byte var8=#0 .and .byte var9=#0	;alte Position var2
			clc										;eins runter
			lda var2
			adc #80
			sta var2
			lda var2+1
			adc #0
			sta var2+1
			#end
			lda (var2),y		;2. Durchgang der Anpassung um letzte 
			sta var8			;Fehler zu beseitigen
			sec
			lda var2
			sbc #40
			sta var2
			lda var2+1
			sbc #0
			sta var2+1
			lda (var2),y
			sta var9
			#if .byte var8>#0 .and .byte var9=#0
			clc
			lda var2
			adc #40
			sta var2
			lda var2+1
			adc #0
			sta var2+1
			#end
			#if .byte var8=#0 .and .byte var9=#0
			clc
			lda var2
			adc #80
			sta var2
			lda var2+1
			adc #0
			sta var2+1
			#end
								;ab hier stimmt die Position des Items (meistens)
								;in der Variable y für x-Position
								;und in var2 für die y-Position 
expl11		
			mva var2 tank1pos		;y-Position für Explosion1
			mva var2+1 tank1pos+1
			mva #68 var5
			jsr fuel.fuelex
			tay
			iny
expl22		
			mva #80 var5
			mva tank1pos var2
			mva tank1pos+1 var2+1
			mva #1 delay
			jsr wartes
			jsr fuel.fuelex
			tay
			iny
expl33		
			mva #92 var5
			mva tank1pos var2
			mva tank1pos+1 var2+1
			mva #1 delay
			jsr wartes
			jsr fuel.fuelex
			tay
			iny
expl44		
			mva #104 var5
			mva tank1pos var2
			mva tank1pos+1 var2+1
			mva #1 delay
			jsr wartes
			jsr fuel.fuelex
			tay
			iny
			rts
	.endp
			; ------------------------------------------------------------------------------

	.proc text
			ldx #0
			lda #52
			jsr prte
			inx
			lda #45
			jsr prte
			inx
			lda #54
			jsr prte
			inx
			lda #31
			jsr prte
			inx
			lda #52
			jsr prte
			inx
			lda #49
			jsr prte
			inx
			lda #0
			jsr prte
			inx
			lda #54
			jsr prte
			inx
			lda #50
			jsr prte
			inx
			lda #0
			jsr prte
			inx
			lda #51
			jsr prte
			inx
			lda #47
			jsr prte
			inx
			lda #50
			jsr prte
			inx
			lda #42
			jsr prte
			inx
			lda #50
			jsr prte
			inx
			lda #53
			jsr prte
			inx
			lda #0
			jsr prte 
			inx
			lda #55
			jsr prte 
			inx
			lda #34
			jsr prte 
			inx
			lda #32
			jsr prte 
			inx
			lda #34
			jsr prte 
			inx
			lda #34
			jsr prte 
			inx
			lda #0
			jsr prte 
			inx
			lda #51
			jsr prte 
			inx
			lda #45
			jsr prte 
			inx
			lda #54
			jsr prte 
			inx
			lda #45
			jsr prte 
			inx
			lda #52
			jsr prte 
			inx
			lda #0
			jsr prte 
			inx
			lda #51
			jsr prte 
			inx
			lda #52
			jsr prte 
			inx
			lda #50
			jsr prte 
			inx
			lda #44
			jsr prte 
			inx
			lda #45
			jsr prte 
			inx
			lda #47
			jsr prte 
			inx
			lda #48
			jsr prte 
			inx 
			lda #0
			jsr prte			
			
			ldx #0		;Fuel
			lda #46
			jsr prte2
			inx
			lda #31
			jsr prte2
			inx
			lda #45
			jsr prte2
			inx
			lda #48
			jsr prte2
			
			ldx #10		;Score
			lda #53
			jsr prte2
			inx
			lda #43
			jsr prte2
			inx
			lda #50
			jsr prte2
			inx
			lda #52
			jsr prte2
			inx
			lda #45
			jsr prte2
			inx
			lda #0
			jsr prte2
			inx
			lda #160
			jsr prte2
			inx
			lda #32
			jsr prte2
			inx
			lda #32
			jsr prte2
			inx
			lda #32
			jsr prte2
			ldx #23		;Ships
			lda #53
			jsr prte2
			inx
			lda #47
			jsr prte2
			inx
			lda #33
			jsr prte2
			inx
			lda #51
			jsr prte2
			inx
			lda #53
			jsr prte2
			inx 
			lda #0
			jsr prte2
			inx
			lda #28
			jsr prte2
			inx
			lda #29
			jsr prte2
			inx 
			lda #0
			jsr prte2
			inx
			lda #28
			jsr prte2
			inx
			lda #29
			jsr prte2
			inx 
			lda #0
			jsr prte2
			inx
			lda #28
			jsr prte2
			inx
			lda #29
			jsr prte2
			ldx #0
fuellauf	
			clc
			lda fuelzaehleritem
@			jsr prte3
			inx
			cpx #36
			bne @-
			rts
prte		sta 30923,x
			sta 32423,x
			rts
prte2		sta 31003,x
			sta 32503,x
			rts
prte3		sta 31043,x
			sta 32543,x
			rts
	.endp
			; ------------------------------------------------------------------------------
			
			
			run main
